include masm32rt.inc

WM_SAVE_BMP equ (WM_USER+1)

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
Bmp2File proto hBmp:DWORD,pszFileName:DWORD
SetWindowClientSize proto :HWND,:DWORD,:DWORD
SetWindowClientPosition proto hWnd:HWND,x:DWORD,y:DWORD

DWM_TNP_RECTDESTINATION 		EQU 1
DWM_TNP_RECTSOURCE				EQU 2
DWM_TNP_OPACITY					EQU 4
DWM_TNP_VISIBLE					EQU 8
DWM_TNP_SOURCECLIENTAREAONLY	EQU 16 

DWM_THUMBNAIL_PROPERTIES struct
	dwFlags        			DWORD	?
	rcDestination  			RECT 	?
	rcSource      			RECT 	?
	opacity         		BYTE 	?
	fVisible        		BOOL 	?
	fSourceClientAreaOnly	BOOL	?
DWM_THUMBNAIL_PROPERTIES ends
PDWM_THUMBNAIL_PROPERTIES typedef ptr DWM_THUMBNAIL_PROPERTIES

HTHUMBNAIL typedef HANDLE
PHTHUMBNAIL typedef ptr HTHUMBNAIL

DWMREGISTERTHUMBNAIL 			typedef proto hwndDestination:HWND,hwndSource:HWND,phThumbnailId:PHTHUMBNAIL
DWMUPDATETHUMBNAILPROPERTIES 	typedef proto hThumbnailId:HTHUMBNAIL,ptnProperties:PDWM_THUMBNAIL_PROPERTIES
DWMUNREGISTERTHUMBNAIL			typedef proto hThumbnailId:HTHUMBNAIL
DWMQUERYTHUMBNAILSOURCESIZE		typedef proto hThumbnail:HTHUMBNAIL,pSize:ptr _SIZE

PDWMREGISTERTHUMBNAIL			typedef ptr DWMREGISTERTHUMBNAIL
PDWMUPDATETHUMBNAILPROPERTIES	typedef ptr DWMUPDATETHUMBNAILPROPERTIES
PDWMUNREGISTERTHUMBNAIL			typedef ptr DWMUNREGISTERTHUMBNAIL
PDWMQUERYTHUMBNAILSOURCESIZE	typedef ptr DWMQUERYTHUMBNAILSOURCESIZE

.data?
	hInstance						HINSTANCE						?
	DwmRegisterThumbnail			PDWMREGISTERTHUMBNAIL			?
	DwmUpdateThumbnailProperties	PDWMUPDATETHUMBNAILPROPERTIES	?
	DwmUnregisterThumbnail			PDWMUNREGISTERTHUMBNAIL			?
	DwmQueryThumbnailSourceSize		PDWMQUERYTHUMBNAILSOURCESIZE	?
	hDrawDC							HDC								?
	dwCounter						DWORD							?
.code
main proc
LOCAL msg:MSG
LOCAL wc:WNDCLASSEX

	.if rv(LoadLibrary,"Dwmapi.dll")
		mov esi,eax
		.if rv(GetProcAddress,esi,"DwmRegisterThumbnail")
			mov DwmRegisterThumbnail,eax
			mov DwmUpdateThumbnailProperties,rv(GetProcAddress,esi,"DwmUpdateThumbnailProperties")
			mov DwmUnregisterThumbnail,rv(GetProcAddress,esi,"DwmUnregisterThumbnail")
			mov DwmQueryThumbnailSourceSize,rv(GetProcAddress,esi,"DwmQueryThumbnailSourceSize")
		.else
			MsgBox "erro while loading API's","error"
			exit
		.endif	
	.else	
		MsgBox "fails to load Dwmapi.dll","error"
		exit
	.endif

	mov hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS or CS_SAVEBITS
	mov wc.lpfnWndProc,WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov wc.lpszClassName,chr$("WinClass32")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,COLOR_WINDOWFRAME
	invoke RegisterClassEx,ADDR wc
	mov edi,rv(CreateWindowEx,0,wc.lpszClassName,chr$("What ever"),WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,000,0,200,200,0,0,hInstance,0)
	
	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg		
	.endw
	
	ret
	
main endp


FindTlws proc hWnd:HWND
	
	invoke EnumWindows,OFFSET EnumProc,hWnd
	invoke SendMessage,hWnd,WM_CLOSE,0,0
	invoke ExitThread,0
	ret
	
FindTlws endp


EnumProc proc hWnd:HWND,lParam:LPARAM
LOCAL dtp:DWM_THUMBNAIL_PROPERTIES
LOCAL thumbnail:HTHUMBNAIL
LOCAL _size:_SIZE
	mov edx,lParam
	.if hWnd != edx
		.if rv(IsWindowVisible,hWnd)
			.if rv(GetWindowTextLength,hWnd)
				.if !rv(DwmRegisterThumbnail,lParam,hWnd,ADDR thumbnail)
					invoke DwmQueryThumbnailSourceSize,thumbnail,ADDR _size
					invoke SetWindowClientSize,lParam,_size.x,_size.y
					invoke SetWindowClientPosition,lParam,0,0
					mov dtp.dwFlags,DWM_TNP_RECTDESTINATION or DWM_TNP_VISIBLE or DWM_TNP_SOURCECLIENTAREAONLY
					mov dtp.fSourceClientAreaOnly,0
					mov dtp.fVisible,1
					mov dtp.opacity,255
					mov dtp.rcDestination.left,0
					mov dtp.rcDestination.top,0
					m2m dtp.rcDestination.right,_size.x
					m2m dtp.rcDestination.bottom,_size.y
					invoke DwmUpdateThumbnailProperties,thumbnail,ADDR dtp
					invoke UpdateWindow,lParam
					invoke Sleep,250
					invoke SendMessage,lParam,WM_SAVE_BMP,hWnd,0
					push eax
					invoke DwmUnregisterThumbnail,thumbnail
					pop eax
					ret
				.endif
			.endif
		.endif
	.endif
	
	mov eax,1
	ret
	
EnumProc endp


WndProc proc uses edi esi ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL rect:RECT
LOCAL dwThreadId:DWORD
LOCAL hMemDC:HDC
LOCAL sz[256]:BYTE

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_CREATE
		invoke CreateThread,0,0,OFFSET FindTlws,hWnd,0,ADDR dwThreadId
	.elseif uMsg == WM_SAVE_BMP
		mov edi,rv(GetDC,hWnd)
		mov hMemDC,rv(CreateCompatibleDC,0)
		invoke GetClientRect,hWnd,ADDR rect
		push rv(SelectObject,hMemDC,rv(CreateCompatibleBitmap,edi,rect.right,rect.bottom))
		invoke ClientToScreen,hWnd,ADDR rect
		invoke BitBlt,hMemDC,0,0,rect.right,rect.bottom,rv(GetDC,0),rect.left,rect.top,SRCCOPY
		pop eax
		mov esi,rv(SelectObject,hMemDC,eax)
		mov sz[0],0
		mkdir "bmp"
		fn Bmp2File,esi,cat$(ADDR sz,"bmp\bmp_",str$(dwCounter),".bmp")
		mov sz[0],0
		mov ebx,fcreate(cat$(ADDR sz,"bmp\bmp_",str$(dwCounter),".bmp:meta"))
		.if rv(GetWindowText,wParam,ADDR sz,SIZEOF sz)
			push eax
			fprintc ebx,"window title:'"
			pop eax
			mov eax,fwrite(ebx,ADDR sz,eax)
			fprintc ebx,chr$("'",0)
		.endif
		fclose ebx
		inc dwCounter
		invoke DeleteDC,hMemDC
		invoke DeleteObject,esi
		invoke ReleaseDC,hWnd,edi
		.if dwCounter < 50 ; some limit
			mov eax,1
		.else
			xor eax,eax
		.endif
		ret
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
WndProc endp

Bmp2File proc uses edi esi hBmp:DWORD,pszFileName:DWORD
LOCAL bi:BITMAPINFO
LOCAL bmp:BITMAP
LOCAL pBits:DWORD
LOCAL hDC:DWORD

    invoke GetObject,hBmp,SIZEOF BITMAP,ADDR bmp     ; get width and hight of bitmap
    test eax,eax
    jz @error   
    
    mov hDC,rv(CreateCompatibleDC,rv(GetDC,0))
    
    mov edx,bmp.bmWidth
    mov eax,bmp.bmHeight

    mov bi.bmiHeader.biSize,SIZEOF BITMAPINFO
    mov bi.bmiHeader.biWidth,edx
    mov bi.bmiHeader.biHeight,eax
    mov bi.bmiHeader.biPlanes,1
    mov bi.bmiHeader.biCompression,BI_RGB
    mov bi.bmiHeader.biBitCount,24                      ; 3 byte per pixel
    mov bi.bmiHeader.biSizeImage,0
    mov bi.bmiHeader.biXPelsPerMeter,0
    mov bi.bmiHeader.biYPelsPerMeter,0
    mov bi.bmiHeader.biClrUsed,0
    mov bi.bmiHeader.biClrImportant,0
    
    mul edx                                                                 ; bmWidth*bmHeight
    lea esi,[eax*2+eax+SIZEOF BITMAPFILEHEADER + SIZEOF BITMAPINFOHEADER]   ; size of *.bmp-file

    mov pBits,rv(GlobalAlloc,GPTR,esi)
    mov edi,eax                                                         ; edi = pointer to BITMAPFILEHEADER
    lea edx,[eax+SIZEOF BITMAPFILEHEADER+SIZEOF BITMAPINFOHEADER]       ; edx = pointer to 

    invoke GetDIBits,hDC,hBmp,0,bmp.bmHeight,edx,ADDR bi,DIB_RGB_COLORS

    assume edi: ptr BITMAPFILEHEADER
    mov [edi].bfType,4D42h                                              ; type = bitmap
    mov [edi].bfSize,esi
    mov [edi].bfOffBits,SIZEOF BITMAPFILEHEADER+SIZEOF BITMAPINFOHEADER ; file offset to bits
    
    lea edi,[edi+BITMAPFILEHEADER]
    assume edi: ptr BITMAPINFOHEADER
    
    cld
    mov edx,esi
    lea esi,bi
    mov ecx,SIZEOF BITMAPINFOHEADER
    rep movsb
    mov esi,edx

    mov edi,fcreate(pszFileName)
    mov ecx,fwrite(edi,pBits,esi)
    fclose(edi) 
    invoke GlobalFree,pBits
    invoke DeleteDC,hDC
    mov eax,1
@error:
    ret

Bmp2File endp  

SetWindowClientSize proc hWnd,_cx:DWORD,cy:DWORD
LOCAL rect[2]:RECT	
	
	
	invoke GetWindowRect,hWnd,ADDR rect
	invoke GetClientRect,hWnd,ADDR rect[16]
	
	mov ecx,_cx
	mov edx,cy
	sub ecx,rect[16].right
	sub edx,rect[16].bottom
	add ecx,rect.right
	add edx,rect.bottom
	sub ecx,rect.left
	sub edx,rect.top
	
	invoke SetWindowPos,hWnd,0,0,0,ecx,edx,SWP_NOMOVE or SWP_NOZORDER	
	
	ret
	
SetWindowClientSize endp

SetWindowClientPosition proc hWnd:HWND,x:DWORD,y:DWORD
LOCAL pt:POINT
LOCAL rect:RECT

	invoke GetWindowRect,hWnd,ADDR rect
	mov pt.x,0
	mov pt.y,0
	invoke ClientToScreen,hWnd,ADDR pt
	
	mov ecx,pt.x
	mov edx,pt.y
	sub ecx,rect.left
	sub edx,rect.top
	
	sub x,ecx
	sub y,edx

	invoke SetWindowPos,hWnd,0,x,y,0,0,SWP_NOSIZE or SWP_NOZORDER	
	
	ret
	
SetWindowClientPosition endp

end main
